(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('@angular/common'), require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('ngx-formulus', ['exports', '@angular/core', '@angular/forms', '@angular/common', 'rxjs', 'rxjs/operators'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["ngx-formulus"] = {}, global.ng.core, global.ng.forms, global.ng.common, global.rxjs, global.rxjs.operators));
})(this, (function (exports, i0, i2, i1, rxjs, operators) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        }
        n["default"] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var i2__namespace = /*#__PURE__*/_interopNamespace(i2);
    var i1__namespace = /*#__PURE__*/_interopNamespace(i1);

    exports.ControlType = void 0;
    (function (ControlType) {
        ControlType["Input"] = "input";
        ControlType["Checkbox"] = "checkbox";
        ControlType["Radio"] = "radio";
        ControlType["Select"] = "select";
        ControlType["Toggle"] = "toggle";
        ControlType["Text"] = "text";
        // Form specific types
        ControlType["SaveButton"] = "save-button";
        ControlType["CloseButton"] = "close-button";
        ControlType["ResetButton"] = "reset-button";
    })(exports.ControlType || (exports.ControlType = {}));
    // TODO: Add datepicker and timepicker

    /**
     * This is not a real service, but it looks like it from the outside.
     * It's just an InjectionTToken used to import the config object, provided from the outside
     */
    var ConfigService = new i0.InjectionToken('NgxFormulusConfig');

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var BaseControlComponent = /** @class */ (function () {
        function BaseControlComponent() {
            this.dynamicControl = {
                formControl: new i2.FormControl(),
                formControlName: '',
                fullWidth: false,
                hidden: false,
                disabled: false,
            };
        }
        BaseControlComponent.prototype.ngOnInit = function () { };
        return BaseControlComponent;
    }());
    BaseControlComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: BaseControlComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    BaseControlComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.8", type: BaseControlComponent, selector: "ngx-base-control", inputs: { dynamicControl: "dynamicControl" }, ngImport: i0__namespace, template: '', isInline: true });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: BaseControlComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'ngx-base-control',
                        template: '',
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { dynamicControl: [{
                    type: i0.Input
                }] } });

    var InputControlComponent = /** @class */ (function (_super) {
        __extends(InputControlComponent, _super);
        function InputControlComponent() {
            return _super.call(this) || this;
        }
        InputControlComponent.prototype.ngOnInit = function () { };
        return InputControlComponent;
    }(BaseControlComponent));
    InputControlComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: InputControlComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    InputControlComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.8", type: InputControlComponent, selector: "ngx-input-control", usesInheritance: true, ngImport: i0__namespace, template: "<div class=\"form-control h-auto\" *ngIf=\"dynamicControl\">\n  <label [for]=\"dynamicControl.formControlName\" *ngIf=\"dynamicControl.label\">{{ dynamicControl.label }}</label>\n  <input [ngClass]=\"{'fullWidth': dynamicControl.fullWidth}\" [id]=\"dynamicControl.formControlName\"\n    [type]=\"dynamicControl.type || 'text'\" [formControl]=\"dynamicControl.formControl\" *ngIf=\"dynamicControl.formControl\"\n    [attr.disabled]=\"dynamicControl.disabled ? '' :\n    null\">\n</div>\n", styles: [".fullWidth{width:100%}\n"], directives: [{ type: i1__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i2__namespace.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i1__namespace.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i2__namespace.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i2__namespace.FormControlDirective, selector: "[formControl]", inputs: ["disabled", "formControl", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: InputControlComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'ngx-input-control',
                        templateUrl: './input-control.component.html',
                        styleUrls: ['./input-control.component.scss'],
                    }]
            }], ctorParameters: function () { return []; } });

    var RadioControlComponent = /** @class */ (function (_super) {
        __extends(RadioControlComponent, _super);
        function RadioControlComponent() {
            return _super.call(this) || this;
        }
        RadioControlComponent.prototype.ngOnInit = function () { };
        return RadioControlComponent;
    }(BaseControlComponent));
    RadioControlComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: RadioControlComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    RadioControlComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.8", type: RadioControlComponent, selector: "ngx-radio-control", usesInheritance: true, ngImport: i0__namespace, template: "<p>radio-control works!</p>\n", styles: [""] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: RadioControlComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'ngx-radio-control',
                        templateUrl: './radio-control.component.html',
                        styleUrls: ['./radio-control.component.scss'],
                    }]
            }], ctorParameters: function () { return []; } });

    var SelectControlComponent = /** @class */ (function (_super) {
        __extends(SelectControlComponent, _super);
        function SelectControlComponent() {
            return _super.call(this) || this;
        }
        SelectControlComponent.prototype.ngOnInit = function () { };
        return SelectControlComponent;
    }(BaseControlComponent));
    SelectControlComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: SelectControlComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    SelectControlComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.8", type: SelectControlComponent, selector: "ngx-select-control", usesInheritance: true, ngImport: i0__namespace, template: "<p>select-control works!</p>\n", styles: [""] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: SelectControlComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'ngx-select-control',
                        templateUrl: './select-control.component.html',
                        styleUrls: ['./select-control.component.scss'],
                    }]
            }], ctorParameters: function () { return []; } });

    var TextControlComponent = /** @class */ (function (_super) {
        __extends(TextControlComponent, _super);
        function TextControlComponent() {
            return _super.call(this) || this;
        }
        TextControlComponent.prototype.ngOnInit = function () { };
        return TextControlComponent;
    }(BaseControlComponent));
    TextControlComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: TextControlComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    TextControlComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.8", type: TextControlComponent, selector: "ngx-text-control", usesInheritance: true, ngImport: i0__namespace, template: "<p>text-control works!</p>\n", styles: [""] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: TextControlComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'ngx-text-control',
                        templateUrl: './text-control.component.html',
                        styleUrls: ['./text-control.component.scss'],
                    }]
            }], ctorParameters: function () { return []; } });

    var CheckboxControlComponent = /** @class */ (function (_super) {
        __extends(CheckboxControlComponent, _super);
        function CheckboxControlComponent() {
            return _super.call(this) || this;
        }
        CheckboxControlComponent.prototype.ngOnInit = function () { };
        return CheckboxControlComponent;
    }(BaseControlComponent));
    CheckboxControlComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: CheckboxControlComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    CheckboxControlComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.8", type: CheckboxControlComponent, selector: "ngx-checkbox-control", usesInheritance: true, ngImport: i0__namespace, template: "<p>checkbox-control works!</p>\n", styles: [""] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: CheckboxControlComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'ngx-checkbox-control',
                        templateUrl: './checkbox-control.component.html',
                        styleUrls: ['./checkbox-control.component.scss'],
                    }]
            }], ctorParameters: function () { return []; } });

    var SaveButtonComponent = /** @class */ (function () {
        function SaveButtonComponent() {
        }
        SaveButtonComponent.prototype.ngOnInit = function () { };
        return SaveButtonComponent;
    }());
    SaveButtonComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: SaveButtonComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    SaveButtonComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.8", type: SaveButtonComponent, selector: "ngx-save-button", ngImport: i0__namespace, template: "<button>Save</button>\n", styles: [""] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: SaveButtonComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'ngx-save-button',
                        templateUrl: './save-button.component.html',
                        styleUrls: ['./save-button.component.scss'],
                    }]
            }], ctorParameters: function () { return []; } });

    var CloseButtonComponent = /** @class */ (function () {
        function CloseButtonComponent() {
        }
        CloseButtonComponent.prototype.ngOnInit = function () { };
        return CloseButtonComponent;
    }());
    CloseButtonComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: CloseButtonComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    CloseButtonComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.8", type: CloseButtonComponent, selector: "ngx-close-button", ngImport: i0__namespace, template: "<button>Close</button>\n", styles: [""] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: CloseButtonComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'ngx-close-button',
                        templateUrl: './close-button.component.html',
                        styleUrls: ['./close-button.component.scss'],
                    }]
            }], ctorParameters: function () { return []; } });

    var ResetButtonComponent = /** @class */ (function () {
        function ResetButtonComponent() {
        }
        ResetButtonComponent.prototype.ngOnInit = function () { };
        return ResetButtonComponent;
    }());
    ResetButtonComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: ResetButtonComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    ResetButtonComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.8", type: ResetButtonComponent, selector: "ngx-reset-button", ngImport: i0__namespace, template: "<button>Reset</button>\n", styles: [""] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: ResetButtonComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'ngx-reset-button',
                        templateUrl: './reset-button.component.html',
                        styleUrls: ['./reset-button.component.scss'],
                    }]
            }], ctorParameters: function () { return []; } });

    var TemplateService = /** @class */ (function () {
        function TemplateService(_config) {
            this._config = _config;
            this.templates = {};
            this.config = _config;
            this.setDefaultTemplates();
            this.mapTemplates();
        }
        /**
         * Get component by ControlType
         * @param controlType
         * @returns Component
         */
        TemplateService.prototype.getComponent = function (controlType) {
            return this.getComponentByType(controlType);
        };
        /**
         * Inject component for specific template
         * @param template
         * @param controlType
         */
        TemplateService.prototype.setTemplate = function (template, controlType) {
            this.templates[controlType] = template;
        };
        Object.defineProperty(TemplateService.prototype, "RegisteredTemplates", {
            /**
             * Get all registered templates
             */
            get: function () {
                return this.templates;
            },
            enumerable: false,
            configurable: true
        });
        // TODO: Add template functionality for every component
        /**
         * Set all default templates for each component
         */
        TemplateService.prototype.setDefaultTemplates = function () {
            // Input
            this.templates[exports.ControlType.Input] = InputControlComponent;
            // Checkbox
            this.templates[exports.ControlType.Checkbox] =
                CheckboxControlComponent;
            // Radio
            this.templates[exports.ControlType.Radio] = RadioControlComponent;
            // Select
            this.templates[exports.ControlType.Select] = SelectControlComponent;
            // Text
            this.templates[exports.ControlType.Text] = TextControlComponent;
            // Form specific components
            this.templates[exports.ControlType.SaveButton] = SaveButtonComponent;
            this.templates[exports.ControlType.CloseButton] = CloseButtonComponent;
            this.templates[exports.ControlType.ResetButton] = ResetButtonComponent;
        };
        /**
         * Map all templates
         */
        TemplateService.prototype.mapTemplates = function () {
            if (this.config && this.config.templates) {
                for (var templateName in this.config.templates) {
                    var template = this.config.templates[templateName];
                    this.templates[templateName] = template;
                }
            }
        };
        /**
         * Get component by ControlType
         * @param type
         * @returns Component
         */
        TemplateService.prototype.getComponentByType = function (type) {
            return this.templates[type];
        };
        return TemplateService;
    }());
    TemplateService.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: TemplateService, deps: [{ token: ConfigService }], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    TemplateService.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: TemplateService, providedIn: 'root' });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: TemplateService, decorators: [{
                type: i0.Injectable,
                args: [{
                        providedIn: 'root',
                    }]
            }], ctorParameters: function () {
            return [{ type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [ConfigService]
                        }] }];
        } });

    var DynamicControlDirective = /** @class */ (function () {
        function DynamicControlDirective(resolver, container, renderer, templateService) {
            this.resolver = resolver;
            this.container = container;
            this.renderer = renderer;
            this.templateService = templateService;
            this.componentRef = null;
            this.dynamicControl = null;
        }
        DynamicControlDirective.prototype.ngOnInit = function () {
            if (this.dynamicControl && this.dynamicControl.type) {
                var component = this.templateService.getComponent(this.dynamicControl.type);
                if (component) {
                    var factory = this.resolver.resolveComponentFactory(component);
                    this.componentRef = this.container.createComponent(factory);
                    this.componentRef.instance.dynamicControl = this.dynamicControl;
                }
            }
        };
        return DynamicControlDirective;
    }());
    DynamicControlDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: DynamicControlDirective, deps: [{ token: i0__namespace.ComponentFactoryResolver }, { token: i0__namespace.ViewContainerRef }, { token: i0__namespace.Renderer2 }, { token: TemplateService }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    DynamicControlDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.8", type: DynamicControlDirective, selector: "[ngxDynamicControl]", inputs: { dynamicControl: "dynamicControl" }, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: DynamicControlDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[ngxDynamicControl]',
                    }]
            }], ctorParameters: function () { return [{ type: i0__namespace.ComponentFactoryResolver }, { type: i0__namespace.ViewContainerRef }, { type: i0__namespace.Renderer2 }, { type: TemplateService }]; }, propDecorators: { dynamicControl: [{
                    type: i0.Input
                }] } });

    var FormControlDirective = /** @class */ (function () {
        function FormControlDirective(resolver, container, templateService) {
            this.resolver = resolver;
            this.container = container;
            this.templateService = templateService;
            this.componentRef = null;
        }
        FormControlDirective.prototype.ngOnInit = function () {
            if (this.formControlType) {
                var component = void 0;
                switch (this.formControlType) {
                    case exports.ControlType.SaveButton:
                        component = this.templateService.getComponent(exports.ControlType.SaveButton);
                        break;
                    case exports.ControlType.CloseButton:
                        component = this.templateService.getComponent(exports.ControlType.CloseButton);
                        break;
                    case exports.ControlType.ResetButton:
                        component = this.templateService.getComponent(exports.ControlType.ResetButton);
                        break;
                    default:
                        component = i0.Component;
                        break;
                }
                if (component) {
                    var factory = this.resolver.resolveComponentFactory(component);
                    this.componentRef = this.container.createComponent(factory);
                }
            }
        };
        return FormControlDirective;
    }());
    FormControlDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: FormControlDirective, deps: [{ token: i0__namespace.ComponentFactoryResolver }, { token: i0__namespace.ViewContainerRef }, { token: TemplateService }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    FormControlDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.8", type: FormControlDirective, selector: "[ngxFormControl]", inputs: { formControlType: "formControlType" }, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: FormControlDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[ngxFormControl]',
                    }]
            }], ctorParameters: function () { return [{ type: i0__namespace.ComponentFactoryResolver }, { type: i0__namespace.ViewContainerRef }, { type: TemplateService }]; }, propDecorators: { formControlType: [{
                    type: i0.Input
                }] } });

    var DynamicFormComponent = /** @class */ (function () {
        function DynamicFormComponent() {
            this.data = null;
            this.dynamicControls = [];
            this.formGroup = new i2.FormGroup({});
            this.formGroups = [];
        }
        DynamicFormComponent.prototype.ngOnInit = function () { };
        return DynamicFormComponent;
    }());
    DynamicFormComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: DynamicFormComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    DynamicFormComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.8", type: DynamicFormComponent, selector: "ngx-dynamic-form", inputs: { data: "data" }, ngImport: i0__namespace, template: "<ng-container *ngIf=\"data\" class=\"h-100 w-100\">\n  <form class=\"w-100 h-100\" [formGroup]=\"data.FormGroup\"\n    *ngIf=\"data && data.FormGroup && data.Controls && data.Controls.length > 0\">\n\n    <div class=\"d-flex flex-row flex-wrap\">\n      <ng-container *ngFor=\"let dynamicControl of data.Controls\">\n        <div class=\"d-flex mr-2 mb-2\" *ngIf=\"dynamicControl && !dynamicControl.hidden\">\n          <ng-container ngxDynamicControl [dynamicControl]=\"dynamicControl\"></ng-container>\n        </div>\n      </ng-container>\n    </div>\n\n    <div class=\"d-flex flex-row\" *ngIf=\"data?.actions\">\n      <div class=\"d-flex\" (click)=\"data.save()\">\n        <ng-container *ngIf=\"data?.actions?.save\" ngxFormControl [formControlType]=\"'save-button'\">\n        </ng-container>\n      </div>\n\n      <div class=\"d-flex ml-2\" (click)=\"data.close()\">\n        <ng-container *ngIf=\"data?.actions?.close\" ngxFormControl [formControlType]=\"'close-button'\">\n        </ng-container>\n      </div>\n\n      <div class=\"d-flex ml-2\" (click)=\"data.reset()\">\n        <ng-container *ngIf=\"data?.actions?.reset\" ngxFormControl [formControlType]=\"'reset-button'\">\n        </ng-container>\n      </div>\n    </div>\n  </form>\n</ng-container>\n", styles: [""], directives: [{ type: i1__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i2__namespace.ɵNgNoValidate, selector: "form:not([ngNoForm]):not([ngNativeValidate])" }, { type: i2__namespace.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { type: i2__namespace.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { type: i1__namespace.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: DynamicControlDirective, selector: "[ngxDynamicControl]", inputs: ["dynamicControl"] }, { type: FormControlDirective, selector: "[ngxFormControl]", inputs: ["formControlType"] }] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: DynamicFormComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'ngx-dynamic-form',
                        templateUrl: './dynamic-form.component.html',
                        styleUrls: ['./dynamic-form.component.scss'],
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { data: [{
                    type: i0.Input
                }] } });

    var ToggleControlComponent = /** @class */ (function (_super) {
        __extends(ToggleControlComponent, _super);
        function ToggleControlComponent() {
            return _super.call(this) || this;
        }
        ToggleControlComponent.prototype.ngOnInit = function () { };
        return ToggleControlComponent;
    }(BaseControlComponent));
    ToggleControlComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: ToggleControlComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    ToggleControlComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.8", type: ToggleControlComponent, selector: "ngx-toggle-control", usesInheritance: true, ngImport: i0__namespace, template: "<p>toggle-control works!</p>\n", styles: [""] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: ToggleControlComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'ngx-toggle-control',
                        templateUrl: './toggle-control.component.html',
                        styleUrls: ['./toggle-control.component.scss'],
                    }]
            }], ctorParameters: function () { return []; } });

    var DatepickerControlComponent = /** @class */ (function (_super) {
        __extends(DatepickerControlComponent, _super);
        function DatepickerControlComponent() {
            return _super.call(this) || this;
        }
        DatepickerControlComponent.prototype.ngOnInit = function () { };
        return DatepickerControlComponent;
    }(BaseControlComponent));
    DatepickerControlComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: DatepickerControlComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    DatepickerControlComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.8", type: DatepickerControlComponent, selector: "ngx-datepicker-control", usesInheritance: true, ngImport: i0__namespace, template: "<p>datepicker-control works!</p>\n", styles: [""] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: DatepickerControlComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'ngx-datepicker-control',
                        templateUrl: './datepicker-control.component.html',
                        styleUrls: ['./datepicker-control.component.scss'],
                    }]
            }], ctorParameters: function () { return []; } });

    var TimepickerControlComponent = /** @class */ (function (_super) {
        __extends(TimepickerControlComponent, _super);
        function TimepickerControlComponent() {
            return _super.call(this) || this;
        }
        TimepickerControlComponent.prototype.ngOnInit = function () { };
        return TimepickerControlComponent;
    }(BaseControlComponent));
    TimepickerControlComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: TimepickerControlComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    TimepickerControlComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.8", type: TimepickerControlComponent, selector: "ngx-timepicker-control", usesInheritance: true, ngImport: i0__namespace, template: "<p>timepicker-control works!</p>\n", styles: [""] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: TimepickerControlComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'ngx-timepicker-control',
                        templateUrl: './timepicker-control.component.html',
                        styleUrls: ['./timepicker-control.component.scss'],
                    }]
            }], ctorParameters: function () { return []; } });

    var NgxFormulusModule = /** @class */ (function () {
        function NgxFormulusModule() {
        }
        NgxFormulusModule.forRoot = function (config) {
            return {
                ngModule: NgxFormulusModule,
                providers: [
                    {
                        provide: ConfigService,
                        useValue: config,
                    },
                ],
            };
        };
        return NgxFormulusModule;
    }());
    NgxFormulusModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: NgxFormulusModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    NgxFormulusModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: NgxFormulusModule, declarations: [DynamicFormComponent,
            BaseControlComponent,
            DynamicControlDirective,
            FormControlDirective,
            InputControlComponent,
            CheckboxControlComponent,
            RadioControlComponent,
            SelectControlComponent,
            ToggleControlComponent,
            TextControlComponent,
            DatepickerControlComponent,
            TimepickerControlComponent,
            SaveButtonComponent,
            CloseButtonComponent,
            ResetButtonComponent], imports: [i1.CommonModule, i2.ReactiveFormsModule, i2.FormsModule], exports: [DynamicFormComponent,
            BaseControlComponent,
            InputControlComponent,
            CheckboxControlComponent,
            DatepickerControlComponent,
            RadioControlComponent,
            SelectControlComponent,
            TextControlComponent,
            TimepickerControlComponent,
            ToggleControlComponent,
            TextControlComponent] });
    NgxFormulusModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: NgxFormulusModule, imports: [[i1.CommonModule, i2.ReactiveFormsModule, i2.FormsModule]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0__namespace, type: NgxFormulusModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [
                            DynamicFormComponent,
                            BaseControlComponent,
                            DynamicControlDirective,
                            FormControlDirective,
                            InputControlComponent,
                            CheckboxControlComponent,
                            RadioControlComponent,
                            SelectControlComponent,
                            ToggleControlComponent,
                            TextControlComponent,
                            DatepickerControlComponent,
                            TimepickerControlComponent,
                            SaveButtonComponent,
                            CloseButtonComponent,
                            ResetButtonComponent,
                        ],
                        imports: [i1.CommonModule, i2.ReactiveFormsModule, i2.FormsModule],
                        exports: [
                            DynamicFormComponent,
                            BaseControlComponent,
                            InputControlComponent,
                            CheckboxControlComponent,
                            DatepickerControlComponent,
                            RadioControlComponent,
                            SelectControlComponent,
                            TextControlComponent,
                            TimepickerControlComponent,
                            ToggleControlComponent,
                            TextControlComponent,
                        ],
                    }]
            }] });

    var DynamicForm = /** @class */ (function () {
        function DynamicForm(config) {
            this.controls = [];
            this.overrides = [];
            this.formGroup = new i2.FormGroup({});
            this.actions = {};
            // Event handling
            this.onSaveSubject = new rxjs.Subject();
            this.onCloseSubject = new rxjs.Subject();
            this.onResetSubject = new rxjs.Subject();
            this.onChangeSubject = new rxjs.Subject();
            this.formGroup = config.formGroup;
            this.overrides = config.overrides || [];
            this.actions = config.actions || {};
            this.mapControls();
            this.initForm();
        }
        /**
         * Get observable for save event
         * @returns Observable
         */
        DynamicForm.prototype.onSave = function () {
            return this.onSaveSubject.asObservable();
        };
        /**
         * Get observable for close event
         * @returns Observable
         */
        DynamicForm.prototype.onClose = function () {
            return this.onCloseSubject.asObservable();
        };
        /**
         * Get observable for reset event
         * @returns Observable
         */
        DynamicForm.prototype.onReset = function () {
            return this.onResetSubject.asObservable();
        };
        /**
         * Get observable for change event
         * @returns Observable
         */
        DynamicForm.prototype.onChange = function () {
            return this.onChangeSubject.asObservable();
        };
        /**
         * Trigger save event
         */
        DynamicForm.prototype.save = function () {
            this.onSaveSubject.next();
        };
        /**
         * Trigger close event
         */
        DynamicForm.prototype.close = function () {
            this.onCloseSubject.next();
        };
        /**
         * Trigger reset event
         */
        DynamicForm.prototype.reset = function () {
            this.onResetSubject.next();
        };
        /**
         * Reload labels
         */
        DynamicForm.prototype.reloadLabels = function () {
            // TODO: Implement dynamic reload for labels or accept observable as label
        };
        /**
         * Reload form
         */
        DynamicForm.prototype.reloadForm = function (_formGroup, _overrides) {
            if (_formGroup) {
                this.formGroup = _formGroup;
            }
            if (_overrides) {
                this.overrides = _overrides;
            }
            this.mapControls();
            this.initForm();
        };
        /**
         * Clean form / reset
         */
        DynamicForm.prototype.cleanForm = function () {
            this.formGroup.reset();
        };
        Object.defineProperty(DynamicForm.prototype, "FormGroup", {
            /**
             * Get FormGroup
             */
            get: function () {
                return this.formGroup;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DynamicForm.prototype, "Controls", {
            /**
             * Get Controls
             */
            get: function () {
                return this.controls || [];
            },
            enumerable: false,
            configurable: true
        });
        /**
         * Init form
         */
        DynamicForm.prototype.initForm = function () {
            var _this = this;
            this.formChange = this.formGroup.valueChanges.pipe(operators.tap(function () {
                _this.onChangeSubject.next();
            }));
        };
        /**
         * Map controls with overrides
         */
        DynamicForm.prototype.mapControls = function () {
            var tempControls = [];
            var formControls = this.formGroup.controls;
            var _loop_1 = function (formControlName) {
                var formControl = formControls[formControlName];
                var newControl = {
                    formControl: formControl,
                    formControlName: formControlName,
                    fullWidth: false,
                    disabled: false,
                    hidden: false,
                };
                var controlOverride = this_1.overrides.find(function (x) { return x.formControlName === formControlName; });
                if (controlOverride) {
                    newControl.label = controlOverride.label || formControlName;
                    newControl.type = controlOverride.type || exports.ControlType.Input;
                    newControl.fullWidth = controlOverride.fullWidth || false;
                    newControl.disabled = controlOverride.disabled || false;
                    newControl.hidden = controlOverride.hidden || false;
                }
                else {
                    newControl.label = formControlName;
                    newControl.type = exports.ControlType.Input;
                }
                tempControls.push(newControl);
            };
            var this_1 = this;
            for (var formControlName in formControls) {
                _loop_1(formControlName);
            }
            this.controls = tempControls;
        };
        return DynamicForm;
    }());

    exports.FormStyle = void 0;
    (function (FormStyle) {
        FormStyle[FormStyle["NgBootstrap"] = 0] = "NgBootstrap";
        FormStyle[FormStyle["Nebular"] = 1] = "Nebular";
        FormStyle[FormStyle["Material"] = 2] = "Material";
    })(exports.FormStyle || (exports.FormStyle = {}));

    /*
     * Public API Surface of ngx-formulus
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.BaseControlComponent = BaseControlComponent;
    exports.CheckboxControlComponent = CheckboxControlComponent;
    exports.CloseButtonComponent = CloseButtonComponent;
    exports.DatepickerControlComponent = DatepickerControlComponent;
    exports.DynamicControlDirective = DynamicControlDirective;
    exports.DynamicForm = DynamicForm;
    exports.DynamicFormComponent = DynamicFormComponent;
    exports.FormControlDirective = FormControlDirective;
    exports.InputControlComponent = InputControlComponent;
    exports.NgxFormulusModule = NgxFormulusModule;
    exports.RadioControlComponent = RadioControlComponent;
    exports.ResetButtonComponent = ResetButtonComponent;
    exports.SaveButtonComponent = SaveButtonComponent;
    exports.SelectControlComponent = SelectControlComponent;
    exports.TemplateService = TemplateService;
    exports.TextControlComponent = TextControlComponent;
    exports.TimepickerControlComponent = TimepickerControlComponent;
    exports.ToggleControlComponent = ToggleControlComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-formulus.umd.js.map
