import * as i0 from '@angular/core';
import { InjectionToken, Component, Input, Injectable, Inject, Directive, NgModule } from '@angular/core';
import * as i2 from '@angular/forms';
import { FormControl, FormGroup, ReactiveFormsModule, FormsModule } from '@angular/forms';
import * as i1 from '@angular/common';
import { CommonModule } from '@angular/common';
import { Subject } from 'rxjs';
import { tap } from 'rxjs/operators';

var ControlType;
(function (ControlType) {
    ControlType["Input"] = "input";
    ControlType["Checkbox"] = "checkbox";
    ControlType["Radio"] = "radio";
    ControlType["Select"] = "select";
    ControlType["Toggle"] = "toggle";
    ControlType["Text"] = "text";
    // Form specific types
    ControlType["SaveButton"] = "save-button";
    ControlType["CloseButton"] = "close-button";
    ControlType["ResetButton"] = "reset-button";
})(ControlType || (ControlType = {}));
// TODO: Add datepicker and timepicker

/**
 * This is not a real service, but it looks like it from the outside.
 * It's just an InjectionTToken used to import the config object, provided from the outside
 */
const ConfigService = new InjectionToken('NgxFormulusConfig');

class BaseControlComponent {
    constructor() {
        this.dynamicControl = {
            formControl: new FormControl(),
            formControlName: '',
            fullWidth: false,
            hidden: false,
            disabled: false,
        };
    }
    ngOnInit() { }
}
BaseControlComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: BaseControlComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BaseControlComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.8", type: BaseControlComponent, selector: "ngx-base-control", inputs: { dynamicControl: "dynamicControl" }, ngImport: i0, template: '', isInline: true });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: BaseControlComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngx-base-control',
                    template: '',
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { dynamicControl: [{
                type: Input
            }] } });

class InputControlComponent extends BaseControlComponent {
    constructor() {
        super();
    }
    ngOnInit() { }
}
InputControlComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: InputControlComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
InputControlComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.8", type: InputControlComponent, selector: "ngx-input-control", usesInheritance: true, ngImport: i0, template: "<div class=\"form-control h-auto\" *ngIf=\"dynamicControl\">\n  <label [for]=\"dynamicControl.formControlName\" *ngIf=\"dynamicControl.label\">{{ dynamicControl.label }}</label>\n  <input [ngClass]=\"{'fullWidth': dynamicControl.fullWidth}\" [id]=\"dynamicControl.formControlName\"\n    [type]=\"dynamicControl.type || 'text'\" [formControl]=\"dynamicControl.formControl\" *ngIf=\"dynamicControl.formControl\"\n    [attr.disabled]=\"dynamicControl.disabled ? '' :\n    null\">\n</div>\n", styles: [".fullWidth{width:100%}\n"], directives: [{ type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i2.FormControlDirective, selector: "[formControl]", inputs: ["disabled", "formControl", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: InputControlComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngx-input-control',
                    templateUrl: './input-control.component.html',
                    styleUrls: ['./input-control.component.scss'],
                }]
        }], ctorParameters: function () { return []; } });

class RadioControlComponent extends BaseControlComponent {
    constructor() {
        super();
    }
    ngOnInit() { }
}
RadioControlComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: RadioControlComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
RadioControlComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.8", type: RadioControlComponent, selector: "ngx-radio-control", usesInheritance: true, ngImport: i0, template: "<p>radio-control works!</p>\n", styles: [""] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: RadioControlComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngx-radio-control',
                    templateUrl: './radio-control.component.html',
                    styleUrls: ['./radio-control.component.scss'],
                }]
        }], ctorParameters: function () { return []; } });

class SelectControlComponent extends BaseControlComponent {
    constructor() {
        super();
    }
    ngOnInit() { }
}
SelectControlComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: SelectControlComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
SelectControlComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.8", type: SelectControlComponent, selector: "ngx-select-control", usesInheritance: true, ngImport: i0, template: "<p>select-control works!</p>\n", styles: [""] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: SelectControlComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngx-select-control',
                    templateUrl: './select-control.component.html',
                    styleUrls: ['./select-control.component.scss'],
                }]
        }], ctorParameters: function () { return []; } });

class TextControlComponent extends BaseControlComponent {
    constructor() {
        super();
    }
    ngOnInit() { }
}
TextControlComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: TextControlComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
TextControlComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.8", type: TextControlComponent, selector: "ngx-text-control", usesInheritance: true, ngImport: i0, template: "<p>text-control works!</p>\n", styles: [""] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: TextControlComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngx-text-control',
                    templateUrl: './text-control.component.html',
                    styleUrls: ['./text-control.component.scss'],
                }]
        }], ctorParameters: function () { return []; } });

class CheckboxControlComponent extends BaseControlComponent {
    constructor() {
        super();
    }
    ngOnInit() { }
}
CheckboxControlComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: CheckboxControlComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
CheckboxControlComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.8", type: CheckboxControlComponent, selector: "ngx-checkbox-control", usesInheritance: true, ngImport: i0, template: "<p>checkbox-control works!</p>\n", styles: [""] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: CheckboxControlComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngx-checkbox-control',
                    templateUrl: './checkbox-control.component.html',
                    styleUrls: ['./checkbox-control.component.scss'],
                }]
        }], ctorParameters: function () { return []; } });

class SaveButtonComponent {
    constructor() { }
    ngOnInit() { }
}
SaveButtonComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: SaveButtonComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
SaveButtonComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.8", type: SaveButtonComponent, selector: "ngx-save-button", ngImport: i0, template: "<button>Save</button>\n", styles: [""] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: SaveButtonComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngx-save-button',
                    templateUrl: './save-button.component.html',
                    styleUrls: ['./save-button.component.scss'],
                }]
        }], ctorParameters: function () { return []; } });

class CloseButtonComponent {
    constructor() { }
    ngOnInit() { }
}
CloseButtonComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: CloseButtonComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
CloseButtonComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.8", type: CloseButtonComponent, selector: "ngx-close-button", ngImport: i0, template: "<button>Close</button>\n", styles: [""] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: CloseButtonComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngx-close-button',
                    templateUrl: './close-button.component.html',
                    styleUrls: ['./close-button.component.scss'],
                }]
        }], ctorParameters: function () { return []; } });

class ResetButtonComponent {
    constructor() { }
    ngOnInit() { }
}
ResetButtonComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: ResetButtonComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
ResetButtonComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.8", type: ResetButtonComponent, selector: "ngx-reset-button", ngImport: i0, template: "<button>Reset</button>\n", styles: [""] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: ResetButtonComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngx-reset-button',
                    templateUrl: './reset-button.component.html',
                    styleUrls: ['./reset-button.component.scss'],
                }]
        }], ctorParameters: function () { return []; } });

class TemplateService {
    constructor(_config) {
        this._config = _config;
        this.templates = {};
        this.config = _config;
        this.setDefaultTemplates();
        this.mapTemplates();
    }
    /**
     * Get component by ControlType
     * @param controlType
     * @returns Component
     */
    getComponent(controlType) {
        return this.getComponentByType(controlType);
    }
    /**
     * Inject component for specific template
     * @param template
     * @param controlType
     */
    setTemplate(template, controlType) {
        this.templates[controlType] = template;
    }
    /**
     * Get all registered templates
     */
    get RegisteredTemplates() {
        return this.templates;
    }
    // TODO: Add template functionality for every component
    /**
     * Set all default templates for each component
     */
    setDefaultTemplates() {
        // Input
        this.templates[ControlType.Input] = InputControlComponent;
        // Checkbox
        this.templates[ControlType.Checkbox] =
            CheckboxControlComponent;
        // Radio
        this.templates[ControlType.Radio] = RadioControlComponent;
        // Select
        this.templates[ControlType.Select] = SelectControlComponent;
        // Text
        this.templates[ControlType.Text] = TextControlComponent;
        // Form specific components
        this.templates[ControlType.SaveButton] = SaveButtonComponent;
        this.templates[ControlType.CloseButton] = CloseButtonComponent;
        this.templates[ControlType.ResetButton] = ResetButtonComponent;
    }
    /**
     * Map all templates
     */
    mapTemplates() {
        if (this.config && this.config.templates) {
            for (const templateName in this.config.templates) {
                const template = this.config.templates[templateName];
                this.templates[templateName] = template;
            }
        }
    }
    /**
     * Get component by ControlType
     * @param type
     * @returns Component
     */
    getComponentByType(type) {
        return this.templates[type];
    }
}
TemplateService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: TemplateService, deps: [{ token: ConfigService }], target: i0.ɵɵFactoryTarget.Injectable });
TemplateService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: TemplateService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: TemplateService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: function () { return [{ type: undefined, decorators: [{
                    type: Inject,
                    args: [ConfigService]
                }] }]; } });

class DynamicControlDirective {
    constructor(resolver, container, renderer, templateService) {
        this.resolver = resolver;
        this.container = container;
        this.renderer = renderer;
        this.templateService = templateService;
        this.componentRef = null;
        this.dynamicControl = null;
    }
    ngOnInit() {
        if (this.dynamicControl && this.dynamicControl.type) {
            const component = this.templateService.getComponent(this.dynamicControl.type);
            if (component) {
                const factory = this.resolver.resolveComponentFactory(component);
                this.componentRef = this.container.createComponent(factory);
                this.componentRef.instance.dynamicControl = this.dynamicControl;
            }
        }
    }
}
DynamicControlDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: DynamicControlDirective, deps: [{ token: i0.ComponentFactoryResolver }, { token: i0.ViewContainerRef }, { token: i0.Renderer2 }, { token: TemplateService }], target: i0.ɵɵFactoryTarget.Directive });
DynamicControlDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.8", type: DynamicControlDirective, selector: "[ngxDynamicControl]", inputs: { dynamicControl: "dynamicControl" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: DynamicControlDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[ngxDynamicControl]',
                }]
        }], ctorParameters: function () { return [{ type: i0.ComponentFactoryResolver }, { type: i0.ViewContainerRef }, { type: i0.Renderer2 }, { type: TemplateService }]; }, propDecorators: { dynamicControl: [{
                type: Input
            }] } });

class FormControlDirective {
    constructor(resolver, container, templateService) {
        this.resolver = resolver;
        this.container = container;
        this.templateService = templateService;
        this.componentRef = null;
    }
    ngOnInit() {
        if (this.formControlType) {
            let component;
            switch (this.formControlType) {
                case ControlType.SaveButton:
                    component = this.templateService.getComponent(ControlType.SaveButton);
                    break;
                case ControlType.CloseButton:
                    component = this.templateService.getComponent(ControlType.CloseButton);
                    break;
                case ControlType.ResetButton:
                    component = this.templateService.getComponent(ControlType.ResetButton);
                    break;
                default:
                    component = Component;
                    break;
            }
            if (component) {
                const factory = this.resolver.resolveComponentFactory(component);
                this.componentRef = this.container.createComponent(factory);
            }
        }
    }
}
FormControlDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: FormControlDirective, deps: [{ token: i0.ComponentFactoryResolver }, { token: i0.ViewContainerRef }, { token: TemplateService }], target: i0.ɵɵFactoryTarget.Directive });
FormControlDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.8", type: FormControlDirective, selector: "[ngxFormControl]", inputs: { formControlType: "formControlType" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: FormControlDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[ngxFormControl]',
                }]
        }], ctorParameters: function () { return [{ type: i0.ComponentFactoryResolver }, { type: i0.ViewContainerRef }, { type: TemplateService }]; }, propDecorators: { formControlType: [{
                type: Input
            }] } });

class DynamicFormComponent {
    constructor() {
        this.data = null;
        this.dynamicControls = [];
        this.formGroup = new FormGroup({});
        this.formGroups = [];
    }
    ngOnInit() { }
}
DynamicFormComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: DynamicFormComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
DynamicFormComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.8", type: DynamicFormComponent, selector: "ngx-dynamic-form", inputs: { data: "data" }, ngImport: i0, template: "<ng-container *ngIf=\"data\" class=\"h-100 w-100\">\n  <form class=\"w-100 h-100\" [formGroup]=\"data.FormGroup\"\n    *ngIf=\"data && data.FormGroup && data.Controls && data.Controls.length > 0\">\n\n    <div class=\"d-flex flex-row flex-wrap\">\n      <ng-container *ngFor=\"let dynamicControl of data.Controls\">\n        <div class=\"d-flex mr-2 mb-2\" *ngIf=\"dynamicControl && !dynamicControl.hidden\">\n          <ng-container ngxDynamicControl [dynamicControl]=\"dynamicControl\"></ng-container>\n        </div>\n      </ng-container>\n    </div>\n\n    <div class=\"d-flex flex-row\" *ngIf=\"data?.actions\">\n      <div class=\"d-flex\" (click)=\"data.save()\">\n        <ng-container *ngIf=\"data?.actions?.save\" ngxFormControl [formControlType]=\"'save-button'\">\n        </ng-container>\n      </div>\n\n      <div class=\"d-flex ml-2\" (click)=\"data.close()\">\n        <ng-container *ngIf=\"data?.actions?.close\" ngxFormControl [formControlType]=\"'close-button'\">\n        </ng-container>\n      </div>\n\n      <div class=\"d-flex ml-2\" (click)=\"data.reset()\">\n        <ng-container *ngIf=\"data?.actions?.reset\" ngxFormControl [formControlType]=\"'reset-button'\">\n        </ng-container>\n      </div>\n    </div>\n  </form>\n</ng-container>\n", styles: [""], directives: [{ type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i2.ɵNgNoValidate, selector: "form:not([ngNoForm]):not([ngNativeValidate])" }, { type: i2.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { type: i2.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: DynamicControlDirective, selector: "[ngxDynamicControl]", inputs: ["dynamicControl"] }, { type: FormControlDirective, selector: "[ngxFormControl]", inputs: ["formControlType"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: DynamicFormComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngx-dynamic-form',
                    templateUrl: './dynamic-form.component.html',
                    styleUrls: ['./dynamic-form.component.scss'],
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { data: [{
                type: Input
            }] } });

class ToggleControlComponent extends BaseControlComponent {
    constructor() {
        super();
    }
    ngOnInit() { }
}
ToggleControlComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: ToggleControlComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
ToggleControlComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.8", type: ToggleControlComponent, selector: "ngx-toggle-control", usesInheritance: true, ngImport: i0, template: "<p>toggle-control works!</p>\n", styles: [""] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: ToggleControlComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngx-toggle-control',
                    templateUrl: './toggle-control.component.html',
                    styleUrls: ['./toggle-control.component.scss'],
                }]
        }], ctorParameters: function () { return []; } });

class DatepickerControlComponent extends BaseControlComponent {
    constructor() {
        super();
    }
    ngOnInit() { }
}
DatepickerControlComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: DatepickerControlComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
DatepickerControlComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.8", type: DatepickerControlComponent, selector: "ngx-datepicker-control", usesInheritance: true, ngImport: i0, template: "<p>datepicker-control works!</p>\n", styles: [""] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: DatepickerControlComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngx-datepicker-control',
                    templateUrl: './datepicker-control.component.html',
                    styleUrls: ['./datepicker-control.component.scss'],
                }]
        }], ctorParameters: function () { return []; } });

class TimepickerControlComponent extends BaseControlComponent {
    constructor() {
        super();
    }
    ngOnInit() { }
}
TimepickerControlComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: TimepickerControlComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
TimepickerControlComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.8", type: TimepickerControlComponent, selector: "ngx-timepicker-control", usesInheritance: true, ngImport: i0, template: "<p>timepicker-control works!</p>\n", styles: [""] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: TimepickerControlComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngx-timepicker-control',
                    templateUrl: './timepicker-control.component.html',
                    styleUrls: ['./timepicker-control.component.scss'],
                }]
        }], ctorParameters: function () { return []; } });

class NgxFormulusModule {
    static forRoot(config) {
        return {
            ngModule: NgxFormulusModule,
            providers: [
                {
                    provide: ConfigService,
                    useValue: config,
                },
            ],
        };
    }
}
NgxFormulusModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: NgxFormulusModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgxFormulusModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: NgxFormulusModule, declarations: [DynamicFormComponent,
        BaseControlComponent,
        DynamicControlDirective,
        FormControlDirective,
        InputControlComponent,
        CheckboxControlComponent,
        RadioControlComponent,
        SelectControlComponent,
        ToggleControlComponent,
        TextControlComponent,
        DatepickerControlComponent,
        TimepickerControlComponent,
        SaveButtonComponent,
        CloseButtonComponent,
        ResetButtonComponent], imports: [CommonModule, ReactiveFormsModule, FormsModule], exports: [DynamicFormComponent,
        BaseControlComponent,
        InputControlComponent,
        CheckboxControlComponent,
        DatepickerControlComponent,
        RadioControlComponent,
        SelectControlComponent,
        TextControlComponent,
        TimepickerControlComponent,
        ToggleControlComponent,
        TextControlComponent] });
NgxFormulusModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: NgxFormulusModule, imports: [[CommonModule, ReactiveFormsModule, FormsModule]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.8", ngImport: i0, type: NgxFormulusModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DynamicFormComponent,
                        BaseControlComponent,
                        DynamicControlDirective,
                        FormControlDirective,
                        InputControlComponent,
                        CheckboxControlComponent,
                        RadioControlComponent,
                        SelectControlComponent,
                        ToggleControlComponent,
                        TextControlComponent,
                        DatepickerControlComponent,
                        TimepickerControlComponent,
                        SaveButtonComponent,
                        CloseButtonComponent,
                        ResetButtonComponent,
                    ],
                    imports: [CommonModule, ReactiveFormsModule, FormsModule],
                    exports: [
                        DynamicFormComponent,
                        BaseControlComponent,
                        InputControlComponent,
                        CheckboxControlComponent,
                        DatepickerControlComponent,
                        RadioControlComponent,
                        SelectControlComponent,
                        TextControlComponent,
                        TimepickerControlComponent,
                        ToggleControlComponent,
                        TextControlComponent,
                    ],
                }]
        }] });

class DynamicForm {
    constructor(config) {
        this.controls = [];
        this.overrides = [];
        this.formGroup = new FormGroup({});
        this.actions = {};
        // Event handling
        this.onSaveSubject = new Subject();
        this.onCloseSubject = new Subject();
        this.onResetSubject = new Subject();
        this.onChangeSubject = new Subject();
        this.formGroup = config.formGroup;
        this.overrides = config.overrides || [];
        this.actions = config.actions || {};
        this.mapControls();
        this.initForm();
    }
    /**
     * Get observable for save event
     * @returns Observable
     */
    onSave() {
        return this.onSaveSubject.asObservable();
    }
    /**
     * Get observable for close event
     * @returns Observable
     */
    onClose() {
        return this.onCloseSubject.asObservable();
    }
    /**
     * Get observable for reset event
     * @returns Observable
     */
    onReset() {
        return this.onResetSubject.asObservable();
    }
    /**
     * Get observable for change event
     * @returns Observable
     */
    onChange() {
        return this.onChangeSubject.asObservable();
    }
    /**
     * Trigger save event
     */
    save() {
        this.onSaveSubject.next();
    }
    /**
     * Trigger close event
     */
    close() {
        this.onCloseSubject.next();
    }
    /**
     * Trigger reset event
     */
    reset() {
        this.onResetSubject.next();
    }
    /**
     * Reload labels
     */
    reloadLabels() {
        // TODO: Implement dynamic reload for labels or accept observable as label
    }
    /**
     * Reload form
     */
    reloadForm(_formGroup, _overrides) {
        if (_formGroup) {
            this.formGroup = _formGroup;
        }
        if (_overrides) {
            this.overrides = _overrides;
        }
        this.mapControls();
        this.initForm();
    }
    /**
     * Clean form / reset
     */
    cleanForm() {
        this.formGroup.reset();
    }
    /**
     * Get FormGroup
     */
    get FormGroup() {
        return this.formGroup;
    }
    /**
     * Get Controls
     */
    get Controls() {
        return this.controls || [];
    }
    /**
     * Init form
     */
    initForm() {
        this.formChange = this.formGroup.valueChanges.pipe(tap(() => {
            this.onChangeSubject.next();
        }));
    }
    /**
     * Map controls with overrides
     */
    mapControls() {
        const tempControls = [];
        const formControls = this.formGroup.controls;
        for (const formControlName in formControls) {
            const formControl = formControls[formControlName];
            const newControl = {
                formControl,
                formControlName,
                fullWidth: false,
                disabled: false,
                hidden: false,
            };
            const controlOverride = this.overrides.find((x) => x.formControlName === formControlName);
            if (controlOverride) {
                newControl.label = controlOverride.label || formControlName;
                newControl.type = controlOverride.type || ControlType.Input;
                newControl.fullWidth = controlOverride.fullWidth || false;
                newControl.disabled = controlOverride.disabled || false;
                newControl.hidden = controlOverride.hidden || false;
            }
            else {
                newControl.label = formControlName;
                newControl.type = ControlType.Input;
            }
            tempControls.push(newControl);
        }
        this.controls = tempControls;
    }
}

var FormStyle;
(function (FormStyle) {
    FormStyle[FormStyle["NgBootstrap"] = 0] = "NgBootstrap";
    FormStyle[FormStyle["Nebular"] = 1] = "Nebular";
    FormStyle[FormStyle["Material"] = 2] = "Material";
})(FormStyle || (FormStyle = {}));

/*
 * Public API Surface of ngx-formulus
 */

/**
 * Generated bundle index. Do not edit.
 */

export { BaseControlComponent, CheckboxControlComponent, CloseButtonComponent, ControlType, DatepickerControlComponent, DynamicControlDirective, DynamicForm, DynamicFormComponent, FormControlDirective, FormStyle, InputControlComponent, NgxFormulusModule, RadioControlComponent, ResetButtonComponent, SaveButtonComponent, SelectControlComponent, TemplateService, TextControlComponent, TimepickerControlComponent, ToggleControlComponent };
//# sourceMappingURL=ngx-formulus.js.map
